Attribute VB_Name = "M_API_Declares"
  Option Explicit
  ' demo project showing how to manipulate a form's system menu
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.
  
  ' IMPORTANT NOTE:  if you don't have the DbgwProc.dll Debug Object from
  ' the MS site, you should get it and use it with this project while in
  ' the IDE.  before compiling an app that uses the debug object, you should
  ' set the DEBUGWINDOWPROC conditional compiliation variable equal to zero.


  Public Const GWL_WNDPROC As Long = (-4&)

  Public Declare Function IsWindow Lib "user32" (ByVal hWnd&) As Long

  Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal cBytes&)

  Public Declare Function SetProp Lib "user32" Alias "SetPropA" (ByVal hWnd As Long, ByVal lpString As String, ByVal hData As Long) As Long
  Public Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hWnd As Long, ByVal lpString As String) As Long
  Public Declare Function RemoveProp Lib "user32" Alias "RemovePropA" (ByVal hWnd&, ByVal lpString$) As Long

  Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd&, _
                                                              ByVal nIndex&, ByVal dwNewLong&) As Long

  Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc&, _
                                               ByVal hWnd&, ByVal Msg&, ByVal wParam&, ByVal lParam&) As Long


  Public Const WM_SYSCOMMAND As Long = &H112&
  Public Const IDM_ABOUT As Long = 1&
  Public Const IDM_WHO As Long = 2&


  Public Const SC_SIZE As Long = &HF000&
  Public Const SC_MOVE As Long = &HF010&
  Public Const SC_CLOSE As Long = &HF060&
  Public Const SC_MINIMIZE As Long = &HF020&
  Public Const SC_MAXIMIZE As Long = &HF030&
  Public Const SC_NEXTWINDOW As Long = &HF040&
  Public Const SC_PREVWINDOW As Long = &HF050&
  Public Const SC_RESTORE As Long = &HF120&
  
  Public Const MF_BYCOMMAND As Long = &H0&
  Public Const MF_BYPOSITION As Long = &H400&

  Public Const MF_STRING As Long = &H0&
  Public Const MF_SEPARATOR As Long = &H800&

  Public Const GWL_STYLE As Long = (-16&)

  Public Const WS_MINIMIZEBOX As Long = &H20000
  Public Const WS_MAXIMIZEBOX As Long = &H10000

  Public Declare Function GetSystemMenu Lib "user32" (ByVal hWnd&, ByVal bRevert&) As Long
  
  Public Declare Function DeleteMenu Lib "user32" (ByVal hMenu&, _
                                                              ByVal nPosition&, ByVal wFlags&) As Long
  
  Public Declare Function AppendMenu Lib "user32" Alias "AppendMenuA" (ByVal hMenu&, _
                                            ByVal wFlags&, ByVal wIDNewItem&, lpNewItem As Any) As Long
                                                                    
  
                                                              
  Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd&, ByVal nIndex&) As Long
                                                              
                                  
  ' SetWindowPos Flags
  Public Const SWP_NOSIZE = &H1
  Public Const SWP_NOMOVE = &H2
  Public Const SWP_NOZORDER = &H4
  Public Const SWP_NOREDRAW = &H8
  Public Const SWP_NOACTIVATE = &H10
  Public Const SWP_FRAMECHANGED = &H20        '  The frame changed: send WM_NCCALCSIZE
  Public Const SWP_SHOWWINDOW = &H40
  Public Const SWP_HIDEWINDOW = &H80
  Public Const SWP_NOCOPYBITS = &H100
  Public Const SWP_NOOWNERZORDER = &H200      '  Don't do owner Z ordering
  
  Public Const SWP_DRAWFRAME = SWP_FRAMECHANGED
  Public Const SWP_NOREPOSITION = SWP_NOOWNERZORDER
  
  ' SetWindowPos() hwndInsertAfter values
  Public Const HWND_TOP = 0
  Public Const HWND_BOTTOM = 1
  Public Const HWND_TOPMOST = -1
  Public Const HWND_NOTOPMOST = -2

  Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd&, ByVal hWndInsertAfter&, ByVal x&, ByVal y&, ByVal cx&, ByVal cy&, ByVal wFlags&) As Long


