VERSION 5.00
Begin VB.Form frmSysMenu 
   AutoRedraw      =   -1  'True
   Caption         =   "System Menu Demo"
   ClientHeight    =   2970
   ClientLeft      =   2370
   ClientTop       =   1425
   ClientWidth     =   6045
   Icon            =   "frmSysMenu.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   198
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   403
   Begin VB.CommandButton Command1 
      Caption         =   "&Exit"
      Height          =   390
      Left            =   330
      TabIndex        =   2
      Top             =   2340
      Width           =   750
   End
   Begin VB.Label Label2 
      Caption         =   "Now try to move me, I dare you!  And don't even think about trying to change my size because you can't!"
      Height          =   495
      Left            =   360
      TabIndex        =   1
      Top             =   1200
      Width           =   5295
   End
   Begin VB.Label Label1 
      Caption         =   "Check out my system menu.  Click on my icon in the upper left corner."
      Height          =   375
      Left            =   360
      TabIndex        =   0
      Top             =   600
      Width           =   5295
   End
End
Attribute VB_Name = "frmSysMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  ' demo project showing how to manipulate a form's system menu
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.
  
  ' IMPORTANT NOTE:  if you don't have the DbgwProc.dll Debug Object from
  ' the MS site, you should get it and use it with this project while in
  ' the IDE.  before compiling an app that uses the debug object, you should
  ' set the DEBUGWINDOWPROC conditional compiliation variable equal to zero.
                   
  ' the subclass procedure is in the cSubclass class module
  Private WithEvents m_oSubclass As cSubclass
Attribute m_oSubclass.VB_VarHelpID = -1
                   
Private Sub Command1_Click()
  ' the user want's out, so let them out
  Unload Me
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  ' keep the user from using Alt+F4 to close the form.  notice
  ' that we have the KeyPreview property for the form set to True
  If KeyCode = vbKeyF4 Then
    KeyCode = 0
    
    MsgBox "Use the 'Exit' button silly!", vbInformation, "System Menu Demo"
  End If
End Sub

Private Sub Form_Load()
  
  ' set the wait cursor in case loading the form takes a while
  Screen.MousePointer = vbHourglass
  
  Dim hSysMenu&
  
  ' first thing to do is get the handle to the system menu for this form
  hSysMenu = GetSystemMenu(hWnd, False)
  
  ' the following removes the close, size, move and maximize items from the system menu.
  Call DeleteMenu(hSysMenu, SC_CLOSE, MF_BYCOMMAND)
  Call DeleteMenu(hSysMenu, SC_SIZE, MF_BYCOMMAND)
  Call DeleteMenu(hSysMenu, SC_MOVE, MF_BYCOMMAND)
  Call DeleteMenu(hSysMenu, SC_MAXIMIZE, MF_BYCOMMAND)
  
  ' change the WS_MAXIMIZEBOX style bit to grey out the maximizebox
  Call SetWindowLong(hWnd, GWL_STYLE, GetWindowLong(hWnd, GWL_STYLE) Xor WS_MAXIMIZEBOX)
    
  ' show the form so we can see how to call SetWindowPos to redraw the close button
  Show

  ' tell the nonclient area of the form to redraw itself
  Call SetWindowPos(hWnd, 0&, 0&, 0&, 0&, 0&, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOZORDER Or SWP_FRAMECHANGED)
  

  ' now we'll add the about item to the bottom of the menu. I've left in a commented call to
  ' append a separator incase you decide to remove the call to delete the close item from the menu.
  ' Since we have the last item in AppendMenu declared "As Any" to allow the use of either
  ' string or long parameters, we need to add the byval so that each will be passed correctly.
  ' one last thing, the ampersand character (&) in the string being assigned to the menus
  ' tells windows to underline the following character in the string which allows the menu item
  ' to be selected by pressing the corresponding key on the keyboard
  
  'Call AppendMenu(hSysMenu, MF_SEPARATOR, False, ByVal 0&)
  Call AppendMenu(hSysMenu, MF_STRING, IDM_ABOUT, ByVal "&About...")
 
  ' add some more fun stuff
  Call AppendMenu(hSysMenu, MF_SEPARATOR, False, ByVal 0&)
  Call AppendMenu(hSysMenu, MF_STRING, IDM_WHO, ByVal "&Who Did This Anyway?")
 
  
  ' create an instance of the cSubclass object and call it's
  ' SubClass method to initiate the subclass for this form
  Set m_oSubclass = New cSubclass
  m_oSubclass.SubClass hWnd

                          
  ' reset the cursor
  Screen.MousePointer = vbDefault
  
cantgetsysmenu:
  ' simple error handler
  If Err Then
    Err.Clear
    
    MsgBox "Unable to load append system menu.", vbExclamation, "System Menu Demo"
  
    Resume cantgetsysmenu
  End If
  
End Sub

Private Sub Form_Unload(Cancel As Integer)

  ' destroy the object so we don't crash since the
  ' subclass is terminated in the Class_Terminate event
  Set m_oSubclass = Nothing
  
End Sub

' these are the events raised in the windowproc in the cSubclass object when menu items are selected
Private Sub m_oSubclass_MenuAbout()
  MsgBox "What do you want to know about this application?", vbQuestion, "System Menu Demo"
End Sub

Private Sub m_oSubclass_MenuWho()
  MsgBox "Why of course, Bryan Stafford of New Vision Software did this!", vbInformation, "New Vision Software"
End Sub
